
// EyeKeyDemoDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "EyeKeyDemo.h"
#include "EyeKeyDemoDlg.h"
#include "EyeKeyApi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define SAFE_DELETE_CJson(pJson)     if (pJson){ cJSON_Delete(pJson); pJson = NULL;}

// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CEyeKeyDemoDlg Ի




CEyeKeyDemoDlg::CEyeKeyDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEyeKeyDemoDlg::IDD, pParent)
    , m_strAppID(_T(""))
    , m_strAppKey(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEyeKeyDemoDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Text(pDX, IDC_EDIT1, m_strAppID);
    DDX_Text(pDX, IDC_EDIT2, m_strAppKey);
}

BEGIN_MESSAGE_MAP(CEyeKeyDemoDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
    ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_CMP, &CEyeKeyDemoDlg::OnBnClickedButtonCmp)
	ON_BN_CLICKED(IDC_BUTTON_IMG1, &CEyeKeyDemoDlg::OnBnClickedButtonImg1)
	ON_BN_CLICKED(IDC_BUTTON_IMG2, &CEyeKeyDemoDlg::OnBnClickedButtonImg2)
END_MESSAGE_MAP()


// CEyeKeyDemoDlg Ϣ

BOOL CEyeKeyDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ
    TCHAR szPath[MAX_PATH] = {0};
    GetModuleFileName(NULL, szPath, MAX_PATH);
    m_strCfgPath = szPath;
    m_strCfgPath = m_strCfgPath.Left(m_strCfgPath.ReverseFind('\\')+1);
    m_strCfgPath += _T("config.ini");
    
    LoadConfig();

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CEyeKeyDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CEyeKeyDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CEyeKeyDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL CEyeKeyDemoDlg::ParseResult( CString &strRes,cJSON*& pJson )
{
    pJson = cJSON_Parse(wstring2string(strRes.GetBuffer(0)).c_str());
    if (!pJson)
    {
        CString strMsg = _T("ûʧ!\n") + strRes;
        AfxMessageBox(strMsg);
        return FALSE;
    }else{
        cJSON* pRet = cJSON_GetObjectItem(pJson,"res_code");
        if (!pRet || strcmp(pRet->valuestring,"0000"))
        {
            cJSON* pMsg = cJSON_GetObjectItem(pJson,"message");
            CString strMsg;
            strMsg.Format(_T("%s\n"), pMsg?string2wstring(pMsg->valuestring).c_str():
                (pRet?string2wstring(pRet->valuestring).c_str():_T(":-1")) );
            AfxMessageBox(strMsg);
            return FALSE;
        }
    }
    return TRUE;
}

void CEyeKeyDemoDlg::OnDestroy()
{
    CDialog::OnDestroy();
    WriteConfig();
    // TODO: ڴ˴Ϣ
}

void CEyeKeyDemoDlg::LoadConfig()
{
    GetPrivateProfileString(_T("AppInfo"),_T("app_id"),_T(""),m_strAppID.GetBuffer(MAX_PATH),MAX_PATH,m_strCfgPath);
    GetPrivateProfileString(_T("AppInfo"),_T("app_key"),_T(""),m_strAppKey.GetBuffer(MAX_PATH),MAX_PATH,m_strCfgPath);
    UpdateData(FALSE);
}

void CEyeKeyDemoDlg::WriteConfig()
{
    UpdateData();
    WritePrivateProfileString(_T("AppInfo"),_T("app_id"),m_strAppID,m_strCfgPath);
    WritePrivateProfileString(_T("AppInfo"),_T("app_key"),m_strAppKey,m_strCfgPath);
}

void CEyeKeyDemoDlg::OnBnClickedButtonCmp()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	if (m_strAppID.IsEmpty() || m_strAppKey.IsEmpty())
	{
		AfxMessageBox(_T("app_id  app_key Ϊ!\n"));
		return;
	}

	CString strPath1, strPath2;
	GetDlgItemText(IDC_EDIT_PATH1, strPath1);
	GetDlgItemText(IDC_EDIT_PATH2, strPath2);

	if (strPath1.IsEmpty() || strPath2.IsEmpty())
	{
		MessageBox(_T("·Ϊ"));
		return;
	}

	EyeKeyApi test(m_strAppID,m_strAppKey);
	CString strRes; strRes.Empty();

	CString strFaceId1, strFaceId2;

	// faceid1
	BOOL bFind1 = FALSE;
	{
		if (!test.Check(strPath1,strRes))
		{
			CString strMsg = _T("ͼƬ̫, ѡС3MͼƬ!\n");
			AfxMessageBox(strMsg);
			return;
		}

		cJSON *pJson = cJSON_Parse(wstring2string(strRes.GetBuffer(0)).c_str());
		if (pJson)
		{
			strFaceId1 = CJSON_FindFirst(pJson, "face_id");
			if (!strFaceId1.IsEmpty())
			{
				bFind1 = TRUE;
			}	
			SAFE_DELETE_CJson(pJson);
		}

		if (!bFind1)
		{
			MessageBox(_T("ͼ1쳣"));
			return;
		}
	}

	// faceid2
	BOOL bFind2 = FALSE;
	{
		if (!test.Check(strPath2, strRes))
		{
			CString strMsg = _T("ͼƬ̫, ѡС3MͼƬ!\n");
			AfxMessageBox(strMsg);
			return;
		}

		cJSON *pJson = cJSON_Parse(wstring2string(strRes.GetBuffer(0)).c_str());
		if (pJson)
		{
			strFaceId2 = CJSON_FindFirst(pJson, "face_id");
			if (!strFaceId2.IsEmpty())
			{
				bFind2 = TRUE;
			}	
			SAFE_DELETE_CJson(pJson);
		}

		if (!bFind2)
		{
			MessageBox(_T("ͼ2쳣"));
			return;
		}
	}
	
	if (test.ComPareFace(strFaceId1, strFaceId2, strRes))
	{
		cJSON *pJson = cJSON_Parse(wstring2string(strRes.GetBuffer(0)).c_str());
		if (pJson)
		{
			CString strMsg;
			cJSON* pSimilarity = cJSON_GetObjectItem(pJson,"similarity");			

			strMsg.Format(_T("\n ƶ:%.2f%%"), pSimilarity?pSimilarity->valuedouble:0);
			SAFE_DELETE_CJson(pSimilarity);
			AfxMessageBox(strMsg);
		}
	}
	else
	{
		MessageBox(_T("fail"));
	}
	//test.Compare

}

void CEyeKeyDemoDlg::OnBnClickedButtonImg1()
{
	UpdateData();
	if (m_strAppID.IsEmpty() || m_strAppKey.IsEmpty())
	{
		AfxMessageBox(_T("app_id  app_key Ϊ!\n"));
		return;
	}

	CFileDialog dlg(TRUE,_T("jpg"),NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,_T("(*.jpg;*.png;*.bmp)|*.jpg;*.png;*.bmp||"));
	dlg.m_ofn.lpstrTitle = _T("ѡͷ");
	if (dlg.DoModal() != IDOK)
	{
		return;
	}

	CString strRes, strFaceId;
	EyeKeyApi test(m_strAppID,m_strAppKey);
	if (!test.Check(dlg.GetPathName(),strRes))
	{
		CString strMsg = _T("ͼƬ̫, ѡС3MͼƬ!\n");
		AfxMessageBox(strMsg);
		return;
	}
	else
	{
		SetDlgItemText(IDC_EDIT_PATH1, dlg.GetPathName());
	}
}

void CEyeKeyDemoDlg::OnBnClickedButtonImg2()
{
	CFileDialog dlg(TRUE,_T("jpg"),NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,_T("(*.jpg;*.png;*.bmp)|*.jpg;*.png;*.bmp||"));
	dlg.m_ofn.lpstrTitle = _T("ѡͷ");
	if (dlg.DoModal() != IDOK)
	{
		return;
	}

	CString strRes, strFaceId;
	EyeKeyApi test(m_strAppID,m_strAppKey);
	if (!test.Check(dlg.GetPathName(),strRes))
	{
		CString strMsg = _T("ͼƬ̫, ѡС3MͼƬ!\n");
		AfxMessageBox(strMsg);
		return;
	}
	else
	{
		SetDlgItemText(IDC_EDIT_PATH2, dlg.GetPathName());
	}
}
